#ifndef MGX_CONFIG_HPP
#define MGX_CONFIG_HPP

#if defined(WIN64) && !defined(WIN32)
  #define WIN32
#endif

#if defined(WIN32) || defined(WIN64)

  #ifdef mgx_EXPORTS
    #define mgx_EXPORT __declspec(dllexport)
  #else
    #define mgx_EXPORT __declspec(dllimport)
  #endif

  #ifdef mgxBase_EXPORTS
    #define mgxBase_EXPORT __declspec(dllexport)
  #else
    #define mgxBase_EXPORT __declspec(dllimport)
  #endif

  #ifdef mgxPython_EXPORTS
    #define mgxPython_EXPORT __declspec(dllexport)
  #else
    #define mgxPython_EXPORT __declspec(dllimport)
  #endif

  #define WINDOWS
  #define _USE_MATH_DEFINES
  #include <windows.h>
  #undef max
  #undef min
  #ifdef _MSC_VER
    #define xor ^
    #define and &&
    #define or ||
    #define not !
    #define finite _finite
    #define isnan _isnan
    #define round _round
  #endif

  #include <math.h>
  #include <float.h>
#else
  #define cuda_EXPORT
  #define mgx_EXPORT
  #define mgxBase_EXPORT
  #define mgxPython_EXPORT
#endif

#endif

