//
// This file is part of MorphoGraphX - http://www.MorphoGraphX.org
// Copyright (C) 2012-2015 Richard S. Smith and collaborators.
//
// If you use MorphoGraphX in your work, please cite:
//   http://dx.doi.org/10.7554/eLife.05864
//
// MorphoGraphX is free software, and is licensed under under the terms of the 
// GNU General (GPL) Public License version 2.0, http://www.gnu.org/licenses.
// 
#ifndef UNORDEREDMAP_HPP
#define UNORDEREDMAP_HPP

#include <Config.hpp>

#ifdef __GNUC__
#  include <Features.hpp>
#  if __GNUC_PREREQ(4, 0)
#    include <tr1/unordered_map>
namespace std {
using namespace std::tr1;
}
#    ifndef HASH_NEED_TR1
#      define HASH_NEED_TR1
#    endif
#  else
#    error "GCC do not have unordered_set before the version 4.0"
#  endif
#else
#  warning "unordered_map is not identified for your compiler. Assumes it's defined as in C++11."
#  include <unordered_map>
#endif

#endif // UNORDEREDMAP_HPP
